#!/usr/bin/perl -w
#---------------------------------------------------------------------------
#
#	cmc.pl -  change a users mozilla configuration
#	----------------------------------------------
#
#	last edit-date: [Tue Feb  3 13:35:44 2009]
#
#	Usage:
#	cmc.pl mozilladir proxy proxyport proxytype noproxy homepage
#	cmc.pl /home/anton myproxy.home.org 8042 2 "localhost, home.org" http://www.home.org
#
#	$Id: cmc.pl,v 1.3 2009/02/03 13:28:50 hm Exp $
#
#---------------------------------------------------------------------------
#
# network.proxy.type 	0 = direct
#			1 = manual
#			2 = PAC
#			3 = mapped to 0
#			4 = WPAD
#---------------------------------------------------------------------------

use strict;

my $pref_file = "prefs.js";
my $pref_bak  = "prefs.js-BAK";
my $inputline = "";

# defaults...

my $proxy = "localhost";
my $port = "8080";
my $noproxy = "localhost";
my $proxytype = "0";
my $basedir = "/tmp";
my $homepage = "";

if ($#ARGV == 5 )
{
	($basedir, $proxy, $port, $proxytype, $noproxy, $homepage ) = @ARGV;
} else {
	print ("\nusage: cnc.pl userhomedir proxy proxyport proxytype noproxy_for homepage\n\n");
	exit(1);
}

system ("cp -p $basedir/$pref_file $basedir/$pref_bak");

open (INFILE, "$basedir/$pref_bak") or die "cannot open $basedir/$pref_bak for read";

open (OUTFILE, ">$basedir/$pref_file") or die "cannot open $basedir/$pref_file for write";

# read inputfile, deleting lines in question

while (<INFILE>) {

	$inputline = $_;

# http
	if (/^user_pref\(\"network.proxy.http\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.http_port\"/)  {
	  $inputline = "";
	}
# ftp
	if (/^user_pref\(\"network.proxy.ftp\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.ftp_port\"/)  {
	  $inputline = "";
	}
# ssl 
	if (/^user_pref\(\"network.proxy.ssl\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.ssl_port\"/)  {
	  $inputline = "";
	}
# gopher
	if (/^user_pref\(\"network.proxy.gopher\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.gopher_port\"/)  {
	  $inputline = "";
	}
# wais
	if (/^user_pref\(\"network.proxy.wais\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.wais_port\"/)  {
	  $inputline = "";
	}
# socks
	if (/^user_pref\(\"network.proxy.socks\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.socks_port\"/)  {
	  $inputline = "";
	}
# other variables
	if (/^user_pref\(\"network.proxy.no_proxies_on\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"network.proxy.type\"/)  {
	  $inputline = "";
	}
	if (/^user_pref\(\"browser.startup.homepage\"/)  {
	  $inputline = "";
	}

	print OUTFILE ("$inputline");
}

close (INFILE);

# append new lines to outputfile

print OUTFILE ( "// \n" );
print OUTFILE ( "// -------------------------------------\n" );
print OUTFILE ( "// appended by /etc/mobile/cmc.pl srcipt\n" );
print OUTFILE ( "// \n" );

print OUTFILE ( "user_pref(\"network.proxy.type\", $proxytype);\n" );
print OUTFILE ( "user_pref(\"browser.startup.homepage\", \"$homepage\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.no_proxies_on\", \"$noproxy\");\n" );

print OUTFILE ( "user_pref(\"network.proxy.http\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.http_port\", $port);\n" );

print OUTFILE ( "user_pref(\"network.proxy.ftp\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.ftp_port\", $port);\n" );

print OUTFILE ( "user_pref(\"network.proxy.ssl\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.ssl_port\", $port);\n" );

print OUTFILE ( "user_pref(\"network.proxy.gopher\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.gopher_port\", $port);\n" );

print OUTFILE ( "user_pref(\"network.proxy.wais\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.wais_port\", $port);\n" );

print OUTFILE ( "user_pref(\"network.proxy.socks\", \"$proxy\");\n" );
print OUTFILE ( "user_pref(\"network.proxy.socks_port\", $port);\n" );

close (OUTFILE);

exit 0;
